#include <PalmOS.h>
// #include <PalmCompatibility.h>
#include <SonyCLIE.h>

#include "dal-res.h"
#include "MyUtility.h"

#define USE_LAUNCH_COMMAND_FOR_NOTIFY

struct dal_pref{
	Boolean isActive;
	UInt32 direct1; // Creator of Direct Launch1
	UInt32 direct2;// Creator of Direct Launch2
} ;

 typedef struct {
	char name[33];
	UInt32 creator;
} application;

typedef struct dal_pref DalPreferenceType;

#define CREATOR  'JDal'
#define AppCreator CREATOR
#define VERSION 1

typedef struct {
	int total_ap;
	int total_dbs;
	int dummy[5];
	char names[5000];
} dal_pref;

#define MAX_DA 200

#define  DA_LAUNCHER_NOTIFY  'JDal'
#define  DA_LAUNCHER_DIRECT1_NOTIFY  'JDa1'
#define  DA_LAUNCHER_DIRECT2_NOTIFY  'JDa2'

#ifndef nil
 #define nil 0
#endif

#define FEATURE_NUM_NOTIFY_REGISTERED 2001
#define FEATURE_NUM_ICON_DB 2002

#define AppChoosenEvent 0x6001

// #define VCHR_LAUNCH_DA 0x6fe0

// for tBMPs
#define BITMAP_RESOURCEID_DUMMY 981
#define BITMAP_RESOURCEID_DIRECT1 982
#define BITMAP_RESOURCEID_DIRECT2 983
// for tSTRs
#define DIRECT1_APP_NAME_RESOURCE_ID 981
#define DIRECT2_APP_NAME_RESOURCE_ID 982
#define LAUNCH_DA_STRING_RESOURCE_ID 983

void InitializePrefs(void);
Boolean ReadPreference(DalPreferenceType *pref);
int	LaunchDA(void);
void SavePreference(DalPreferenceType *pref);
UInt16 notify_receiver( SysNotifyParamType *param);
void Launch1DA(UInt32 creator);
UInt16 notify_receiver_direct1( SysNotifyParamType *param);
UInt16 notify_receiver_direct2( SysNotifyParamType *param);
Err SendDatabase (UInt16 cardNo,LocalID dbID,char * nameP,char * descriptionP);
void InstallSampleDA(void);
